﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Dapper;
using Dapper.Contrib.Extensions;

namespace IntroDapper
{
    class Program
    {
        static void Main(string[] args)
        {
            SqlMapperExtensions.TableNameMapper += (type) =>
            {
                return type.Name;
            };

            string nome = string.Empty;
            do
            {
                Console.WriteLine("Digite o nome:");
                nome = Console.ReadLine();
                if (!string.IsNullOrWhiteSpace(nome))
                {
                    Console.WriteLine("Digite o sobrenome:");
                    var sobrenome = Console.ReadLine();
                    if (!string.IsNullOrWhiteSpace(sobrenome))
                    {
                        var pessoa = new Pessoa()
                        {
                            Nome = nome,
                            Sobrenome = sobrenome
                        };
                        CadastrarPessoaNoBanco(pessoa);
                    }
                }

                ListarPessoas();
            }
            while (!string.IsNullOrWhiteSpace(nome));

            Console.ReadLine();
        }
        private static void CadastrarPessoaNoBanco(Pessoa pessoa)
        {
            //using (var conn = new System.Data.SQLite.SQLiteConnection("Data Source=db.db;Version=3;"))
            //{
            //    conn.Open();
            //    if (conn.State == System.Data.ConnectionState.Open)
            //    {
            //        using (var comm = new System.Data.SQLite.SQLiteCommand("INSERT INTO Pessoa (Nome, Sobrenome) VALUES (@Nome, @Sobrenome)", conn))
            //        {
            //            comm.Parameters.AddWithValue("Nome", pessoa.Nome);
            //            comm.Parameters.AddWithValue("Sobrenome", pessoa.Sobrenome);
            //            comm.ExecuteNonQuery();
            //        }
            //    }
            //}

            //using (var conn = new System.Data.SQLite.SQLiteConnection("Data Source=db.db;Version=3;"))
            //{
            //    conn.Open();
            //    if (conn.State == System.Data.ConnectionState.Open)
            //    {
            //        conn.Execute(
            //            "INSERT INTO Pessoa (Nome, Sobrenome) VALUES (@Nome, @Sobrenome)",
            //            new { Nome = pessoa.Nome, Sobrenome = pessoa.Sobrenome });
            //    }
            //}

            using (var conn = new System.Data.SQLite.SQLiteConnection("Data Source=db.db;Version=3;"))
            {
                conn.Open();
                if (conn.State == System.Data.ConnectionState.Open)
                {
                    conn.Insert(pessoa);
                }
            }
        }
        private static void ListarPessoas()
        {
            Console.WriteLine("======= Listagem de pessoas =======");

            var pessoas = CarregarPessoasDoBanco();
            foreach (var pessoa in pessoas)
            {
                Console.WriteLine("Id: {0}, Nome: {1}, Sobrenome: {2}", pessoa.Id, pessoa.Nome, pessoa.Sobrenome);
            }

            Console.WriteLine("===================================");
        }
        private static IEnumerable<Pessoa> CarregarPessoasDoBanco()
        {
            //var pessoas = new List<Pessoa>();

            //using (var conn = new System.Data.SQLite.SQLiteConnection("Data Source=db.db;Version=3;"))
            //{
            //    conn.Open();
            //    if (conn.State == System.Data.ConnectionState.Open)
            //    {
            //        using (var comm = new System.Data.SQLite.SQLiteCommand("SELECT * FROM Pessoa", conn))
            //        using (var reader = comm.ExecuteReader())
            //        {
            //            while (reader.Read())
            //            {
            //                var pessoa = new Pessoa();
            //                pessoa.Id = Convert.ToInt32(reader["Id"]);
            //                pessoa.Nome = reader["Nome"].ToString();
            //                pessoa.Sobrenome = reader["Sobrenome"].ToString();
            //                pessoas.Add(pessoa);
            //            }
            //        }
            //    }
            //}

            //return pessoas;

            IEnumerable<Pessoa> pessoas = null;

            using (var conn = new System.Data.SQLite.SQLiteConnection("Data Source=db.db;Version=3;"))
            {
                conn.Open();
                if (conn.State == System.Data.ConnectionState.Open)
                {
                    //pessoas = conn.Query<Pessoa>("SELECT * FROM Pessoa");
                    pessoas = conn.GetAll<Pessoa>();
                }
            }

            return pessoas;
        }
    }
}
